# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

from gi.repository import Gtk # pylint: disable=E0611

from fsgamer_lib.helpers import get_builder
from fsgamer.ConfirmcloseDialog import ConfirmcloseDialog

import gettext
from gettext import gettext as _
gettext.textdomain('fsgamer')

import logging
logger = logging.getLogger('fsgamer')

try:
    import notifications_listener
except ImportError:
    print("Error: cannot trap notifications since notification python"+
            "interface couldn't be found :( ")

class FsgrunDialog(Gtk.Window):
    __gtype_name__ = "FsgrunDialog"

    def __new__(cls):
        builder = get_builder('FsgrunDialog')
        new_object = builder.get_object('fsgrun_dialog')
        new_object.init(builder)
        return new_object

    def init(self, builder):
        """Set up the main window"""
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.ui = builder.get_ui(self)
        self.ui.back_to_game.hide()

        self.ConfirmcloseDialog = ConfirmcloseDialog
        self.confirm_close = None

    def _show_cc(self):
        if self.confirm_close is not None:
            logger.debug('show existing choose_dialog')
            self.confirm_close.present()
        elif self.ConfirmcloseDialog is not None:
            logger.debug('create new ConfirmcloseDialog')
            self.confirm_close = self.ConfirmcloseDialog() # pylint: disable=E1102
            self.confirm_close.app = self.app
            self.confirm_close.show()

    def on_force_game_quit(self, widget, data=None):
        self._show_cc()

    def on_destroy(self, widget, data=None):
        self.app.kill()
        Gtk.main_quit()

    def set_run_application(self, app):
        self.app = app

        icon_theme = Gtk.IconTheme.get_default()
        game_pixbuf = app.get_pixbuf(icon_theme, 128)

        self.ui.game_icon.set_from_pixbuf(game_pixbuf)
        self.ui.game_label.set_text(app.get_name())

        #icon = self.ui.game_icon.new_from_pixbuf(app.get_pixbuf(icon_theme, 128))
        self.set_title("%s - Running in FSGamer" % app.get_name())
        self.set_icon(game_pixbuf)
        app.run()




