import utils
import os

# Wrapper around openbox

OPENBOX_PATH = utils.shell_run.which("openbox")
ENABLED = bool(OPENBOX_PATH)



class _XML:
    def __call__(self, tag, *children, **props):
        s = '<' + tag


        for key, val in props.iteritems():
            s += '  %s="%s"' % (key, val.replace('"', r'\"'))
        s += '>\n' + "\n".join(children)
        s += '\n</%s>\n' % tag
        return s

    def keybind(self, key, command=None):
        return xml("keybind",
                        xml("action", 
                                xml("command", command),
                                name="Execute"
                            ),
                        key=key
                    )

ALT_TAB_WARNING = "To switch back to your desktop, use Ctrl+Alt+F7. To terminate this game completely, use Ctrl+Alt+Delete"

xml = _XML()

def make_conf(exe):
    amixer_path = utils.shell_run.which('amixer')
    xmessage_cmd = 'xmessage -buttons "" -center -timeout 2 "%s"' % ALT_TAB_WARNING

    bindings = ''
    # Add in keybindgings for mixer
    if amixer_path:
        cmd = "%s -q sset Master " % amixer_path
        bindings = '\n'.join([
                xml.keybind("XF86AudioRaiseVolume", cmd+"5%+"),
                xml.keybind("XF86AudioLowerVolume", cmd+"5%-"),
                xml.keybind("XF86AudioMute", cmd+"toggle")
            ])

    # Add in Alt-Tab warning
    bindings += xml.keybind("A-Tab", xmessage_cmd)

    # Control-Alt-Delete to rudely kill all
    bindings += xml.keybind("A-C-Delete",
                    utils.unparse_options({ 'killall': True , 'exec': exe}))

    return xml("keyboard", bindings)

CONF_PATH = os.path.join(utils.get_data_path(), "ui", "openbox_conf.xml")
TEMPLATE = '%s --sm-disable --config-file %s --startup %s'
def main(exe, opts):
    data = open(CONF_PATH).read()
    extra_conf = make_conf(exe) + opts.get('openbox_config', '')

    data = data.replace("<!--[[END]]-->", extra_conf)

    path = utils.write_tmp_file("openbox_conf.xml", data)

    cmd = TEMPLATE % (OPENBOX_PATH, path, exe)

    utils.shell_run(cmd, replace=True)


if __name__ == "__main__":
    main()

