"""
Simple interprocess communication, use send() to send to the server running listen()
"""
import glib
import dbus
from dbus.mainloop.glib import DBusGMainLoop

import SocketServer
import socket
import sys

PORT = 9497
HOST = "localhost"

def send(data, port=PORT, host=HOST):
    # Create a socket (SOCK_STREAM means a TCP socket)
    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

    try:
        # Connect to server and send data
        sock.connect((host, port))
        sock.sendall(data)

        # Receive data from the server and shut down
        received = sock.recv(1024)
    finally:
        sock.close()

    return received

def listen(callback, port=PORT, host=HOST):
    class MyTCPHandler(SocketServer.StreamRequestHandler):
        def handle(self):
            result = callback(self.rfile)
            self.wfile.write(result)

    # Create the server
    server = SocketServer.TCPServer((host, port), MyTCPHandler)

    # And activate the server
    server.serve_forever()

