# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2013 Michael Bethencourt michaelpb@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

from gi.repository import Gtk # pylint: disable=E0611

from fsgamer_lib.helpers import get_builder

import gettext
import sys
import fsgamer_app as fsg_app
from gettext import gettext as _
gettext.textdomain('fsgamer')

class ConfirmcloseDialog(Gtk.Dialog):
    __gtype_name__ = "ConfirmcloseDialog"

    def __new__(cls):
        """Special static method that's automatically called by Python when 
        constructing a new instance of this class.
        
        Returns a fully instantiated ConfirmcloseDialog object.
        """
        builder = get_builder('ConfirmcloseDialog')
        new_object = builder.get_object('confirmclose_dialog')
        new_object.finish_initializing(builder)
        return new_object

    def finish_initializing(self, builder):
        """Called when we're finished initializing.

        finish_initalizing should be called after parsing the ui definition
        and creating a ConfirmcloseDialog object with it in order to
        finish initializing the start of the new ConfirmcloseDialog
        instance.
        """
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.ui = builder.get_ui(self)

    def on_btn_ok_clicked(self, widget, data=None):
        """The user has elected to save the changes.

        Called before the dialog returns Gtk.ResponseType.OK from run().
        """
        self.app.kill()
        self.hide()
        Gtk.main_quit()
        sys.exit(0)

    def on_btn_cancel_clicked(self, widget, data=None):
        """The user has elected cancel changes.

        Called before the dialog returns Gtk.ResponseType.CANCEL for run()
        """
        self.hide()


if __name__ == "__main__":
    dialog = ConfirmcloseDialog()
    dialog.show()
    Gtk.main()
